=== tests/requirements.txt ===
coverage==7.13.0
filelock>=3.20.1
pytest==9.0.2
pluggy==1.6.0
pytest-mock==3.15.1
pytest-timeout==2.4.0
pytest-xdist==3.8.0
